{
    import java.io.InputStream;
    import java.io.FileInputStream;
}

/**
 * A simplified XML parser example.
 */
class SimpleXMLParser extends Parser;

{ 
    public static void main(String args[]) throws Exception {
        String fileNames[] = {null};
        if (args.length != 0) {
            fileNames = args;
        }
        for (int i = 0; i < args.length; i++) {
            final InputStream is;
            if (args[i] == null) {
                is = System.in;
            } else {
                is = new FileInputStream(args[i]);
            }
            final SimpleXMLParser parser = 
                new SimpleXMLParser(new SimpleXMLLexer(is));
            if (args[i] != null) {
                // TBD: Set file name on the scanner, or does the Parser
                // handle this?
                parser.setFilename(args[i]);
            }
            parser.doc();
        }
    }
}


doc     : elt EOF
        ;
elt     : "<" NAME (attr)* ">" (elt | CDATA)* "</" NAME ">"
        ;
attr    : NAME "=" "\"" NAME "\""
        ;


class SimpleXMLLexer extends Lexer;

WS      : (' '
          | '\t'
          | 
          ( ('\r' '\n') => '\r' '\n'
          | '\r'
          | '\n'
          ) { newline(); })+
        {$setType(Token.SKIP);}
        ;
protected
NAME    : (('a' .. 'z') | ('A' .. 'Z'))+
        ;
CDATA   : (NAME '<') => NAME { $setType(CDATA); }
        // (NAME (NAME | ">" | "=" | "\""))
          | NAME { $setType(NAME); }
        ;
OTHER   : ({LA(2) == '/'}? "</" 
        | '<' 
        | '>' |  '"' | '=')
        ;
